<template>
  <q-page padding>
    <MatchedComponent
      v-if="matched"
      :person="persons[topIndex]"
      @close="
        () => {
          matched = false;
          topIndex++;
        }
      "
    />
    <ul v-if="persons[topIndex] && !matched">
      <li
        v-for="(person, index) in persons"
        :key="index"
        class="person-with-mark"
      >
        <PersonComponent
          :class="{ top: index === topIndex }"
          style="position: absolute; top: 10px; max-height: 70vh"
          :data="person"
          menu="matchingPage"
        />
      </li>
      <div class="buttons-wrapper">
        <q-img
          @click="accept"
          src="/icons/accept.png"
          spinner-color="white"
          style="height: 40px; max-width: 40px"
        />
        <q-img
          @click="reject"
          src="/icons/reject.png"
          spinner-color="white"
          style="height: 40px; max-width: 40px"
        />
      </div>
    </ul>
  </q-page>
</template>

<script setup lang="ts">
import { ref } from 'vue';

import { api } from '../boot/axios';

import { useUserStore } from '../stores/user';
import PersonComponent from 'src/components/PersonComponent.vue';
import MatchedComponent from 'src/components/MatchedComponent.vue';

defineOptions({
  name: 'MatchingPage',
});

const userStore = useUserStore();
const { user } = userStore;

interface UserProfile {
  id: number;
  nick: string;
  photos: string;
  state: string;
  email: string;
  city_id: number;
  distance: number | null;
  age: number;
  sex: number;
  height: number;
  about: string;
  loggedIn: number;
  ageRange: number | null;
  status: string;
  relation: string;
  handshake: number | null;
  visited: number;
  userFromId: number;
  userToId: number;
  name: string;
  type: string;
  province: string;
  district: string;
  commune: string;
  latitude: string;
  longitude: string;
}

interface PersonToDisplay {
  nick: string;
  age: number;
  image: string;
  lazyImage: string;
  city: string;
  loggedIn: boolean;
}

const persons = ref<PersonToDisplay[]>([]);
const topIndex = ref<number>(0);
const matched = ref<boolean>(false);
getPersons();
function getPersons() {
  api
    .get('/user/close-friends-sorted', {
      params: { uuid: user.uuid },
    })
    .then(({ data }) => {
      persons.value = data.map((person: UserProfile) => {
        return {
          nick: person.nick,
          age: person.age,
          image: JSON.parse(person.photos).profile,
          lazyImage: JSON.parse(person.photos).profile,
          city: person.name,
          loggedIn: person.loggedIn,
        };
      });
    })
    .catch((err) => {
      console.error(err);
    });
}
function accept() {
  api
    .put('/user/accept', {
      uuid: user.uuid,
      nick: persons.value[topIndex.value].nick,
    })
    .then(({ data }) => {
      if (data.relation === 'accepted') {
        matched.value = true;
      } else {
        topIndex.value++;
        if (persons.value[topIndex.value]) return;
      }
    })
    .catch((err) => {
      console.error(err);
    });
}
function reject() {
  topIndex.value++;
  if (!persons.value[topIndex.value]) return;
}
</script>
<style scoped lang="scss">
.person-with-mark {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}

.buttons-wrapper {
  position: relative;
  z-index: 1001;
  top: 500px;
}
@media (max-width: 960px) {
  .buttons-wrapper {
    display: flex;
    flex-direction: row;
    justify-content: space-evenly;
    width: 100%;
  }
}
@media (min-width: 961px) {
  .buttons-wrapper {
    display: flex;
    flex-direction: row;
    // justify-content: space-evenly;
    & > *:nth-child(2) {
      margin-left: 70px;
    }
    @media (min-width: 960px) {
      width: 50%;
    }
  }
}
.top {
  z-index: 999;
}
</style>
